#!/bin/sh

mylog(){
	r=1;
	t=0;
	while [ $((2*r)) -le $1 ]
	do
		t=$((t+1));
		r=$((2*r));
	done;
	echo $t
}

# $1...cislo
# $2...size
# $3...max_n
generate_batch(){
	batch=$(printf "%02d" $1)
	max_largeness=$(($(mylog "$3")-1))
	./gen "$3" $(($2<=max_largeness?$2:max_largeness)) "$1" 1 l $(($2<=max_largeness?$2:max_largeness)) > inp/${batch}a.in

	./gen $(($3<=$2?$3:$2)) $(($3<=$2?$3:$2)) "$1" 2 r > inp/${batch}b.in

	./gen "$3" $2 "$1" 3 r > inp/${batch}c.in
	./gen "$3" $2 "$1" 4 r > inp/${batch}d.in
	./gen "$3" $2 "$1" 5 r > inp/${batch}e.in
	./gen "$3" $2 "$1" 6 r > inp/${batch}f.in
	./gen "$3" $2 "$1" 7 r > inp/${batch}g.in
	./gen "$3" $2 "$1" 8 r > inp/${batch}h.in
	./gen "$3" $2 "$1" 9 r > inp/${batch}i.in

	if [ $2 -eq 100000 ] && [ $3 -eq 1000000000 ]; then
		./gen "$3" "$2" "$1" 10 l 10 > inp/${batch}j.in
	else
		./gen "$3" $2 "$1" 10 r > inp/${batch}j.in
	fi

}

rm -rf inp
mkdir inp

generate_batch 1 20 1024

generate_batch 2 20 1000000000
generate_batch 3 20 1000000000
generate_batch 4 400 1024
generate_batch 5 800 1024
generate_batch 6 100000 1000000000
generate_batch 7 100000 1000000000
generate_batch 8 100000 1000000000
generate_batch 9 100000 1000000000
generate_batch 10 100000 1000000000
