#include <vector>
#include <iostream>


// nejvzssi mocnina dvojky delici x
int two_valuation(int x){
	if(x <= 0)return -1;
	int ret = 1;
	while(0 == (x % (ret*2)))ret*=2;
	return ret;
}

// pocet jednicek v bin. zapise x
int popcount(int x){
	int ret = 0;
	for(; x>0; x>>=1){
		ret+=x&1;
	}
	return ret;
}

int main(){
	std::vector<int> input;
	int n; // n <= 20

	std::cin >> n;
	input.resize(n);

	for(int i = 0; i < n; i++){
		std::cin >> input[i];
	}

	int best = 0;
	int best_bm = 0;
	// bm je bitmaska, tj. indikatorova funkce aktualne zkousene podmnoziny
	for(int bm = 1; bm < (1<<n); bm++){
		int ret = (1<<30)-1; // same jednicky, tj. neutralni prvek pro AND
		for(int i = 0; i < n; i++)if(bm & (1<<i)){
			ret &= input[i];
		}
		int v2 = two_valuation(ret);
		if(v2 > best){
			best = v2;
			best_bm = bm;
		}
	}

	std::cout << popcount(best_bm) << std::endl;
	for(int i = 0; i < n; i++)if(best_bm & (1<<i)){
		std::cout << input[i] << " ";
	}
	std::cout << std::endl;

}